package jp.mehve.nicofilter.filter.nicofilter;

import jp.mehve.xml.XMLEncoding;

public class NicoChat implements Cloneable {
    public String  date;
    public String  mail;
    public String  no;
    public String  premium;
    public String  thread;
    public String  userId;
    public String  vpos;
    public String  comment;
    public boolean removed;

    public NicoChat(String date, String mail, String no, String premium, String thread, String userId, String vpos) {
        this.date = date;
        this.mail = mail;
        this.no = no;
        this.premium = premium;
        this.thread = thread;
        this.userId = userId;
        this.vpos = vpos;
        this.removed = false;
    }

    @Override
    public NicoChat clone() {
        NicoChat chat = new NicoChat(date, mail, no, premium, thread, userId, vpos);
        chat.comment = this.comment;

        return chat;
    }

    public void toXMLString(StringBuffer buf) {
        // <chat date="1180660961" mail="shita red" no="2718"
        // thread="1180470813" user_id="1158775" vpos="38220">What's?</chat>
        buf.append("<chat");
        if (date != null) {
            buf.append(" date=\"").append(XMLEncoding.escapeXML(date)).append("\"");
        }
        if (mail != null) {
            buf.append(" mail=\"").append(XMLEncoding.escapeXML(mail)).append("\"");
        }
        if (no != null) {
            buf.append(" no=\"").append(XMLEncoding.escapeXML(no)).append("\"");
        }
        if (premium != null) {
            buf.append(" premium=\"").append(XMLEncoding.escapeXML(premium)).append("\"");
        }
        if (thread != null) {
            buf.append(" thread=\"").append(XMLEncoding.escapeXML(thread)).append("\"");
        }
        if (userId != null) {
            buf.append(" user_id=\"").append(XMLEncoding.escapeXML(userId)).append("\"");
        }
        if (vpos != null) {
            buf.append(" vpos=\"").append(XMLEncoding.escapeXML(vpos)).append("\"");
        }
        buf.append(">");
        if (comment != null) {
            buf.append(XMLEncoding.escapeXML(comment));
        }
        buf.append("</chat>");
    }
}
