package jp.mehve.nicofilter.filter.nicofilter;

import java.util.ArrayList;

import jp.mehve.xml.XMLEncoding;

// <packet>
//  <thread last_res="" resultcode="" thread="" ticket="" />
//  <view_counter video="">
//  <chat ... />*
// </packet>
//
public class Nicomment {
    private NicoThread          nicoThread;
    private NicoViewCounter     nicoCounter;
    private ArrayList<NicoChat> nicoChats;

    public Nicomment(NicoThread nicoThread, NicoViewCounter nicoCounter, ArrayList<NicoChat> nicoChats) {
        this.nicoThread = nicoThread;
        this.nicoCounter = nicoCounter;
        this.nicoChats = nicoChats;
    }

    public ArrayList<NicoChat> getNicoChats() {
        return this.nicoChats;
    }

    public NicoThread getNicoThread() {
        return this.nicoThread;
    }

    public NicoViewCounter getNicoViewCounter() {
        return this.nicoCounter;
    }
    
    public void setNicoChats(ArrayList<NicoChat> nicoChats) {
        this.nicoChats = nicoChats;
    }

    private void toXMLStringSub(StringBuffer buf) {
        buf.append("<packet>");
        this.nicoThread.toXMLString(buf);
        this.nicoCounter.toXMLString(buf);
        for (NicoChat chat : this.nicoChats) {
            chat.toXMLString(buf);
        }
        buf.append("</packet>");
    }
    
    public String toXMLStringWithoutXMLDecl() {
        StringBuffer buf = new StringBuffer();
        toXMLStringSub(buf);
        return buf.toString();
    }
    
    public String toXMLStringWithXMLDecl() {
        StringBuffer buf = new StringBuffer();
        buf.append("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
        toXMLStringSub(buf);
        
        return buf.toString();
    }
}

class NicoThread {
    public String lastRes;
    public String resultCode;
    public String thread;
    public String ticket;
    
    public NicoThread(String lastRes, String resultCode, String thread, String ticket) {
        this.lastRes = lastRes;
        this.resultCode = resultCode;
        this.thread = thread;
        this.ticket = ticket;
    }
    
    public void toXMLString(StringBuffer buf) {
        // <thread last_res="3717" resultcode="0" thread="1180470813" ticket="0xb3291b0"/>
        buf.append("<thread");
        buf.append(" last_res=\"").append(XMLEncoding.escapeXML(lastRes)).append("\"");
        buf.append(" resultcode=\"").append(XMLEncoding.escapeXML(resultCode)).append("\"");
        buf.append(" thread=\"").append(XMLEncoding.escapeXML(thread)).append("\"");
        buf.append(" ticket=\"").append(XMLEncoding.escapeXML(ticket)).append("\"");
        buf.append("/>");
    }
}

class NicoViewCounter {
    public String video;

    public NicoViewCounter(String video) {
        this.video = video;
    }
    
    public void toXMLString(StringBuffer buf) {
        // <view_counter video="5398"/>
        buf.append("<view_counter");
        buf.append(" video=\"").append(XMLEncoding.escapeXML(video)).append("\"");
        buf.append("/>");
    }
}
