package jp.mehve.nicofilter.mainui;

import java.net.HttpURLConnection;
import java.net.InetSocketAddress;
import java.net.URL;
import java.util.concurrent.Executors;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import jp.mehve.httpproxy.ProxyHandler;
import jp.mehve.nicofilter.filter.nicofilter.NicommentFilter;

import compat.com.sun.net.httpserver.HttpContext;
import compat.com.sun.net.httpserver.HttpServer;

public class Main {
    private static final String VERSION_TITLE = "NicoFilter α３";
    private static MainFrame       mainFrame    = null;
    private static HttpServer      server       = null;
    private static NicommentFilter nicoFilter   = null;
    private static ConfigHolder    configHolder = null;

    public static NicommentFilter getNicommentFilter() {
        return nicoFilter;
    }

    public static void main(String[] args) {
        configHolder = new ConfigHolder();
        configHolder.load("config.xml");
        
        Runtime.getRuntime().addShutdownHook(new Thread() {
            @Override
            public void run() {
                configHolder.save("config.xml");
            }
        });

        nicoFilter = new NicommentFilter(configHolder);

        mainFrame = new MainFrame(VERSION_TITLE, configHolder);
        mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        mainFrame.setVisible(true);
        
        startProxy();
    }

    public static boolean isProxyRunning() {
        return (server != null);
    }

    public static MainFrame getMainFrame() {
        return mainFrame;
    }

    public static synchronized void startProxy() {
        if (server != null) { return; }
        try {
            server = HttpServer.create(new InetSocketAddress(8080), 100);
        } catch (Exception e) {
            server = null;
            JOptionPane.showMessageDialog(mainFrame, "Proxy is not started.\nPort 8080 is used by another application.", "alert", JOptionPane.ERROR_MESSAGE);
            return;
        }

        HttpContext cxt = server.createContext("/", new ProxyHandler());
        cxt.getFilters().add(nicoFilter);
        server.setExecutor(Executors.newCachedThreadPool());
        server.start();

        mainFrame.repaint();
    }

    public static synchronized void stopProxy() {
        if (server == null) { return; }

        server.stop(0);
        server = null;

        mainFrame.repaint();
    }

    public static synchronized void getComment() {
        if (server == null) { return; }
        if (nicoFilter == null) { return; }

        String cookie = nicoFilter.getStolenCookie();
        String stolenThreadNo = "1182655909";
        if (cookie == null || stolenThreadNo == null) { return; }
        // <thread>
        // <thread res_from="-250" version="20061206" thread="1181578922" />

        try {
            String threadNo = nicoFilter.getStolenThreadNo();
            if (threadNo == null) { return; }
            URL url = new URL("http://msg12.nicovideo.jp/api/");
            HttpURLConnection con = (HttpURLConnection) url.openConnection();
            con.setDoOutput(true);
            con.setInstanceFollowRedirects(false);

            String body = "<thread res_from=\"-250\" version=\"20061206\"" + " thread=\"" + stolenThreadNo + "\" />";
            byte[] ba = body.getBytes("utf-8");

            con.setRequestMethod("POST");
            con.setRequestProperty("Referer", "http://www.nicovideo.jp/");
            con.setRequestProperty("Cookie", cookie);
            con.setRequestProperty("Host", "www.nicovideo.jp");
            con.setRequestProperty("Content-length", String.valueOf(ba.length));
            con.getOutputStream().write(ba);

            con.connect();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
