package jp.mehve.nicofilter.mainui;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JToolBar;

public class MainFrame extends JFrame implements ActionListener {

    private static String MENU_EXIT        = "Exit";
    private static String MENU_ABOUT       = "About";
    // XXX: This class shouldn't have config.
    private ConfigHolder  config;

    public MainFrame(String title, ConfigHolder config) {
        super(title);
        this.config = config;
        setBounds(50, 50, 550, 250);
        createGUI();
    }

    private void createGUI() {
        createMenu();
        createView();
    }

    private void createView() {
        JPanel mainPanel = new JPanel();
        mainPanel.setLayout(new BorderLayout());
        setContentPane(mainPanel);

        // JToolBar toolBar = new JToolBar();
        // toolBar.add(new JButton(new ImageIcon("./img/stop.png")));
        // toolBar.add(new JButton(new ImageIcon("./img/start.png")));
        // mainPanel.add(toolBar, BorderLayout.NORTH);

        InformationPanel panel = new InformationPanel(Main.getNicommentFilter(), config);
        mainPanel.add(panel, BorderLayout.CENTER);
    }

    private void createMenu() {
        MenuBar menuBar = new MenuBar();
        setMenuBar(menuBar);

        {
            // [File]
            Menu menu = new Menu("File");
            menuBar.add(menu);

            MenuItem exit = new MenuItem(MENU_EXIT);
            exit.addActionListener(this);
            menu.add(exit);
        }
        
        {
            // [Help]
            Menu menu = new Menu("Help");
            menuBar.add(menu);
            
            MenuItem about = new MenuItem(MENU_ABOUT);
            about.addActionListener(this);
            menu.add(about);
        }

        // {
        // // [Proxy]
        // Menu menu = new Menu("Proxy");
        // menuBar.add(menu);
        //
        // MenuItem start = new MenuItem(MENU_PROXY_START);
        // start.addActionListener(this);
        // menu.add(start);
        //
        // MenuItem stop = new MenuItem(MENU_PROXY_STOP);
        // stop.addActionListener(this);
        // menu.add(stop);
        // }
        //
        // {
        // // [Filter]
        // Menu menu = new Menu("Filter");
        // menuBar.add(menu);
        //
        // MenuItem getNicomment = new MenuItem(MENU_GET_COMMENT);
        // getNicomment.addActionListener(this);
        // menu.add(getNicomment);
        // }
    }

    public void actionPerformed(ActionEvent ae) {
        String command = ae.getActionCommand();

        if (MENU_EXIT.equals(command)) {
            System.exit(0);
        } else if (MENU_ABOUT.equals(command)) {
            String message = "NicoFilter\n(C) mayah 2007 All rights reserved.\nhttp://mayah.jp/archive/2007/nico";
            JOptionPane.showMessageDialog(this, message);
        } else {
            // DO_NOTHING
        }

    }

}
