/**
 * SList.java
 * Copyright (C) KAWANAKA Shinya 2006- All Rights Reserved
 * 
 * Created: 2007/03/29
 * $Id$
 *
 * @author shinyak
 */
package jp.mehve.util;

/**
 * @author shinyak
 *
 */
public class SList<T> {
    private T elem;
    private SList<T> tail;
    
    public SList(T val, SList<T> tail) {
        this.elem = val;
        this.tail = tail;
    }
    
    public T hd() {
    	return elem;
    }
    
    public SList<T> tl() {
    	return tail;
    }
    
    public static<T> SList<T> append(SList<T> s1, SList<T> s2) {
        SList<T> srev = reverse(s1);
        
        SList<T> ret = s2;
        while (srev != null) {
            ret = new SList<T>(srev.elem, ret);
            srev = srev.tail;
        }
        
        return ret;
    }
    
    public static<T> SList<T> reverse(SList<T> s) {
        SList<T> v = null;
        while (s != null) {
            v = new SList<T>(s.elem, v);
            s = s.tail;
        }
        
        return v;
    }
}

