package jp.mehve.util;

/**
 * Pair.java
 * Copyright (C) KAWANAKA Shinya 2006- All Rights Reserved
 * 
 * Created: 2007/03/26
 * $Id$
 *
 * @author shinyak
 */

/**
 * generic 3-tuple.
 * 
 * @author shinyak
 * 
 */
public class Triple<F, S, T> {
    private final F first;
    private final S second;
    private final T third;

    /**
     * create new 3-tuple
     * 
     * @param first
     *            first element
     * @param second
     *            second element
     * @param third
     *            third element
     */
    public Triple(F first, S second, T third) {
        this.first = first;
        this.second = second;
        this.third = third;
    }

    /**
     * get the first element
     * 
     * @return first element
     */
    public F getFirst() {
        return first;
    }

    /**
     * get the second element
     * 
     * @return
     */
    public S getSecond() {
        return second;
    }

    /**
     * get the third element
     * 
     * @return
     */
    public T getThird() {
        return third;
    }
}
